package org.agilefaqs.rft;

import java.util.List;

import org.agilefaqs.rft.internal.Domain;
import org.agilefaqs.rft.internal.MatchingCriterion;

class CriterionMatcher {
    private final List<EmailHeader> mailHeaders;
    private int counter;
    private Domain mxRecord;

    CriterionMatcher(final List<EmailHeader> mailHeaders) {
        this.mailHeaders = mailHeaders;
    }

    CriterionMatcher and(final Domain mxRecord) {
        this.mxRecord = mxRecord;
        return this;
    }

    Match match(final MatchingCriterion criterion) {
        for (EmailHeader header : mailHeaders) {
            counter++;

            if (criterion.isSatisfiedBy(mxRecord, header)) {
                return new Match(header.fromDomain, header.fromIp, counter);
            }
        }
        return Match.NULL;
    }
}
