package org.agilefaqs.rft;

import static org.agilefaqs.rft.internal.IPAddress.parse;

import org.agilefaqs.rft.internal.Domain;
import org.agilefaqs.rft.internal.DomainFactory;
import org.agilefaqs.rft.internal.IPAddress;

public class EmailHeader {
    public final IPAddress byIp;
    public final Domain byDomain;
    public final IPAddress fromIp;
    public final Domain fromDomain;

    public EmailHeader(final String receivedFromIp, final String receivedFromDomain, final String receivedByIp,
            final String receivedByDomain, final Network network) {
        byDomain = DomainFactory.build(receivedByDomain, network);
        fromDomain = DomainFactory.build(receivedFromDomain, network);
        byIp = parse(receivedByIp);
        fromIp = parse(receivedFromIp);
    }
}
