package org.agilefaqs.rft;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Collections;
import java.util.List;

public class Network {
    public static final Network NULL = new Network() {
        @Override
        public List<String> firstMXRecordFor(final String name) {
            return Collections.emptyList();
        }

        @Override
        public String ipAddressOf(final String domainName) throws UnknownHostException {
            return "";
        };

        @Override
        public String hostNameFor(final String ipAddress) throws UnknownHostException {
            return "";
        };
    };

    public String ipAddressOf(final String domainName) throws UnknownHostException {
        return lookUpFor(domainName).getHostAddress();
    }

    public String hostNameFor(final String ipAddress) throws UnknownHostException {
        return lookUpFor(ipAddress).getHostName();
    }

    private InetAddress lookUpFor(final String value) throws UnknownHostException {
        return InetAddress.getByName(value);
    }

    public List<String> firstMXRecordFor(final String name) {
        return Collections.emptyList();
    }
}
