package org.agilefaqs.rft.internal;

import static org.junit.Assert.assertEquals;

import org.agilefaqs.rft.FakeNetwork;
import org.junit.Test;

public class DomainTest {
    private static final FakeNetwork FAKE_NETWORK = new FakeNetwork();

    @Test
    public void fetchSecondLevelDomain() {
        Domain agilefaqs_mail = parse("mail.agileFAQs.com");
        Domain agilefaqs = agilefaqs_mail.secondLevelDomain();
        assertEquals("agilefaqs.com", agilefaqs.toString());
    }

    @Test
    public void domainsCanBeSecondLevelDomain() {
        Domain agilefaqs = parse("agileFAQs.com").secondLevelDomain();
        assertEquals("agilefaqs.com", agilefaqs.toString());
    }

    @Test
    public void retrieveFirstMxRecord() {
        Domain agileIndia = parse("mail.agileindia.org").retrieveFirstMXRecord();
        assertEquals("agileindia.org", agileIndia.toString());
    }

    @Test
    public void storeNameInLowerCase() {
        assertEquals("agilefaqs.com", parse("AGILEFAQS.COM").toString());
    }

    @Test
    public void resolveIPAddress() {
        IPAddress google = parse("mail-vw0-f172.google.com").resolveIP();
        assertEquals("209.85.212.172", google.toString());
    }

    private Domain parse(final String domainName) {
        return DomainFactory.build(domainName, FAKE_NETWORK);
    }
}
