package org.agilefaqs.rft.internal;

import static org.agilefaqs.rft.internal.IPAddress.parse;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class IPAddressTest {
    private String ipAddressToBeParsed;

    @Test
    public void parseStringsContainingValidIPAddress() {
        assertWhen("192.168.0.1").isParsedWeGet("192.168.0.1");
        assertWhen("[192.168.0.1]").isParsedWeGet("192.168.0.1");
    }

    @Test
    public void invalidIPsAreMappedToNullIPAddress() {
        assertFalse(parse("192.invalid.ip.address").isValid());
        assertFalse(parse(null).isValid());
        assertFalse(parse("").isValid());
    }

    @Test
    public void idenitfyLocalHost() {
        assertTrue(IPAddress.parse("127.0.0.1").isLocalhost());
    }

    private IPAddressTest assertWhen(final String ipAddress) {
        ipAddressToBeParsed = ipAddress;
        return this;
    }

    private void isParsedWeGet(final String ipAddress) {
        assertEquals(ipAddress, IPAddress.parse(ipAddressToBeParsed).toString());
    }
}
